<?php
namespace Teknisa\Model\Teknisa\Repositories;


class Contratolinp extends \Doctrine\ORM\EntityRepository {

    public function findBillingReferringToMonth($clientId)
    {
        $query = <<<SQL
            SELECT DISTINCT CL.DTMESAPURLINP,
                   TO_CHAR(CL.DTMESAPURLINP,'DD/MM/YYYY') AS DTMESAPURFAS,
                   TO_CHAR(CL.DTMESAPURLINP,'MONTH/YYYY' ) AS DTFATURAMENTO
              FROM CONTRATOLINPAPU CL
             WHERE CL.CDCLIENTE = :P_CDCLIENTE
               AND EXISTS (SELECT AP.*
                             FROM APURFATUFAS AP
                            WHERE AP.CDCLIENTE = CL.CDCLIENTE
                              AND AP.CDLINPCLIE = CL.CDLINPCLIE
                              AND AP.IDAPURFATFAS = '6' -- MANUTENÇÃO E LOCAÇÃO
                              AND AP.IDSTAPFATFAS = 'R') -- FATURADA
             ORDER BY CL.DTMESAPURLINP DESC
SQL;
        $params = array('P_CDCLIENTE' => $clientId);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);

    }

    public function findOpenBillings($clientId)
    {
        $query = <<<SQL
        SELECT
       DECODE(CDUSUTPMEDIDASERV, NULL, GREATEST(QTMINIMAFATLINP, QTVALIDAS), NRUSUALINPC) AS VARIABLEMEASURE,
       CDUSUTPMEDIDASERV,
       NRSEQCONTRATO,
       NRPRODUTO_ID,
       CAIXAS,
       CDCLIENTE,
       CDGRUPONFLINPC,
       CDLINPCLIE,
       CDLINPCLIEINFOR,
       DTFVIGVRLINP,
       DTHOJE,
       DTIVIGVRLINP,
       MODE_LOCATION,
       IDTIPLINPC,
       IDTIPLINPC_FORM,
       NRUSUALINPC,
       QTATIVAS,
       QTMINIMAFATLINP,
       QTSISTEMAS,
       QTVALIDAS,
       VRLICENCUSOLINP,
       VRMENSALIDALINP,
       DTFATURAMENTO,
       GROUPED,
       VRTOTALMENSAL,
       NMLINPCLIE_AUX,
       NMLINPCLIE,
       NRCONTRATOFCT,
       DSREFERENCIACONT,
       /*(VRTOTALMENSAL * VRPERCDESCMAN / 100) AS VRDESCMANUTENCAO,
       VRTOTALMENSAL - (VRTOTALMENSAL * VRPERCDESCMAN / 100) AS VRTOTMANUTENCAO*/
       VRDESCMAN AS VRDESCMANUTENCAO,
       VRTOTALMENSAL - VRDESCMAN AS VRTOTMANUTENCAO
  FROM (
    SELECT OMP.CDUSUTPMEDIDASERV,
           CA.NRSEQCONTRATO,
           CA.NRPRODUTO_ID,
           CAIXAS,
           CDCLIENTE,
           CDGRUPONFLINPC,
           CDLINPCLIE,
           CDLINPCLIEINFOR,
           DTFVIGVRLINP,
           DTHOJE,
           DTIVIGVRLINP,
           IDMPROCLINPC || '/' || IDLPROCLINPC AS MODE_LOCATION,
           IDTIPLINPC,
           IDTIPLINPC AS IDTIPLINPC_FORM,
           NRUSUALINPC,
           QTATIVAS,
           QTMINIMAFATLINP,
           QTSISTEMAS,
           QTVALIDAS,
           NVL(ITLU.VRUNITITEMCONT, VRLICENCUSOLINP) AS VRLICENCUSOLINP,
           NVL(ITMAN.VRUNITITEMCONT, VRMENSALIDALINP) AS VRMENSALIDALINP,
           '' AS DTFATURAMENTO,
           ' ' AS GROUPED,
           DECODE(CDUSUTPMEDIDASERV, NULL,
           CASE WHEN (QTMINIMAFATLINP > QTVALIDAS )
                THEN QTMINIMAFATLINP * NVL(ITMAN.VRUNITITEMCONT, VRMENSALIDALINP)
                ELSE QTVALIDAS * NVL(ITMAN.VRUNITITEMCONT, VRMENSALIDALINP)
            END,
            NRUSUALINPC * NVL(ITMAN.VRUNITITEMCONT, VRMENSALIDALINP)) AS VRTOTALMENSAL,
            NMLINPCLIE AS NMLINPCLIE_AUX,
            (NMLINPCLIE || ' - ' || '(' ||
            (SELECT RTRIM(XMLAGG(XMLELEMENT(e,SI.SGSISTEMA ,', ').EXTRACT('//text()')).GetClobVal(),', ')
                     FROM SISTCONTLINP SC, SISTEMA SI, PROCOMERCI PR
                     WHERE SC.CDCLIENTE = :P_CDCLIENTE
                     AND SC.CDLINPCLIE = CA.CDLINPCLIE
                     AND SI.CDSISTEMA = SC.CDSISTEMA
                     AND PR.CDPROCOMERCI = SI.CDPROCOMERCI) || ')') AS NMLINPCLIE,
            CONT.NRCONTRATOFCT,
            CONT.DSREFERENCIACONT,
            ITMAN.VRPERCDESCITEM AS VRPERCDESCMAN,
            ITMAN.VRDESCITEM AS VRDESCMAN

      FROM (SELECT CX.CAIXAS, C.NRSEQCONTRATO, C.NRPRODUTO_ID, T.*
              FROM TABLE (LINHA_PRODUTO_FAT (:P_CDCLIENTE)) T, CONTRATOLINP C,
                   (SELECT CO.CDCLIENTE, CO.CDLINPCLIE, CO.NMLINPCLIE, NVL(CN.TOTAL,0) AS CAIXAS
                      FROM CONTRATOLINP CO,
                           (SELECT SUM(C.TOTAL) AS TOTAL, L.CDLINPCLIE
                              FROM LINPLUSO L,
                                   (SELECT CDCLIENTE, NRLICENCAUSO, COUNT(CDCAIXALUSO) AS TOTAL
                                      FROM CAIXALUSO
                                     WHERE CDCLIENTE= :P_CDCLIENTE
                                  GROUP BY CDCLIENTE, NRLICENCAUSO
                                   )C
                             WHERE L.CDCLIENTE    = C.CDCLIENTE
                               AND L.NRLICENCAUSO = C.NRLICENCAUSO
                          GROUP BY L.CDLINPCLIE
                           ) CN
                      WHERE CO.CDLINPCLIE = CN.CDLINPCLIE(+)
                        AND CO.CDCLIENTE = :P_CDCLIENTE
                   ) CX
             WHERE T.CDCLIENTE = CX.CDCLIENTE
               AND T.CDLINPCLIE = CX.CDLINPCLIE
               AND C.CDCLIENTE = T.CDCLIENTE
               AND C.CDLINPCLIE = T.CDLINPCLIE) CA,
               FCT_CONTRATO CONT,
            (SELECT NEG.NRSEQCONTRATO,
                    ITCONT.IDELEMENTO,
                    DECODE(NVL(NEG.VRPERCDESCITEM, 0), 0, NVL(ITNEG.VRPERCDESCITEM, 0), NVL(NEG.VRPERCDESCITEM, 0)) AS VRPERCDESCITEM,
                    DECODE(NVL(NEG.VRDESCITEM, 0), 0, NVL(ITNEG.VRDESCITEM, 0), NVL(NEG.VRDESCITEM, 0)) AS VRDESCITEM,
                    ITCONT.VRUNITITEMCONT
               FROM FCT_NEGOCIACAOCONTRATO NEG
              INNER JOIN FCT_ITEMCONTRATO ITCONT
                 ON NEG.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
              INNER JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG
                 ON NEG.NRNEGOCIACAOCONTRATO = ITNEG.NRNEGOCIACAOCONTRATO
                AND ITCONT.NRITEMOCONTRATO = ITNEG.NRITEMOCONTRATO
              INNER JOIN FCT_SERVICOORCA SERV
                 ON ITCONT.CDSERVORCA = SERV.CDSERVORCA
              WHERE SERV.IDLICENUSOMANUT = 'M') ITMAN,
            (SELECT ITCONT.NRSEQCONTRATO,
                    ITCONT.IDELEMENTO,
                    ITCONT.VRUNITITEMCONT
               FROM FCT_ITEMCONTRATO ITCONT
              INNER JOIN FCT_SERVICOORCA SERV
                 ON ITCONT.CDSERVORCA = SERV.CDSERVORCA
              WHERE SERV.IDLICENUSOMANUT = 'L') ITLU,

              OM_PRODUTO OMP

           WHERE CA.NRSEQCONTRATO = CONT.NRSEQCONTRATO(+)
             AND CA.NRSEQCONTRATO = ITMAN.NRSEQCONTRATO(+)
             AND ITMAN.IDELEMENTO(+) = 'P_' || CA.NRPRODUTO_ID
             AND CA.NRSEQCONTRATO = ITLU.NRSEQCONTRATO(+)
             AND ITLU.IDELEMENTO(+) = 'P_' || CA.NRPRODUTO_ID
             AND OMP.ID(+) = CA.NRPRODUTO_ID
     ORDER BY DECODE(IDTIPLINPC, 'M', 1, 'L', 1, 'P', 2, 'A', 2, NULL, 0), NMLINPCLIE_AUX)

SQL;
        $params = array('P_CDCLIENTE' => $clientId);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }


    public function verifyProductDiscount($clientId)
    {
        $query = <<<SQL
            SELECT DISTINCT NRSEQCONTRATO,
       DECODE(NRSEQCONTRATO, NULL, 0, VRDESCLICENCAUSO) AS VRDESCLICENCAUSO,
       DECODE(NRSEQCONTRATO, NULL, VRTOTALLU, VRTOTLICENCAUSO) AS VRTOTLICENCAUSO,
       DECODE(NRSEQCONTRATO, NULL, NULL , VRDESCMANUTENCAO) AS VRDESCMANUTENCAO
  FROM (
    SELECT CA.NRSEQCONTRATO,
           CA.NRPRODUTO_ID,
           CAIXAS,
           CDCLIENTE,
           CDGRUPONFLINPC,
           CDLINPCLIE,
           CDLINPCLIEINFOR,
           DTFVIGVRLINP,
           DTHOJE,
           DTIVIGVRLINP,
           IDMPROCLINPC || '/' || IDLPROCLINPC AS MODE_LOCATION,
           IDTIPLINPC,
           IDTIPLINPC AS IDTIPLINPC_FORM,
           NRUSUALINPC,
           QTATIVAS,
           QTMINIMAFATLINP,
           QTSISTEMAS,
           QTVALIDAS,
           NVL(ITLU.VRTOTITEM, VRLICENCUSOLINP) AS VRLICENCUSOLINP,
           NVL(ITMAN.VRTOTITEM, VRMENSALIDALINP) AS VRMENSALIDALINP,
           '' AS DTFATURAMENTO,
           ' ' AS GROUPED,
           CASE WHEN (QTMINIMAFATLINP > QTVALIDAS )
                THEN QTMINIMAFATLINP * NVL(ITMAN.VRTOTITEM, VRMENSALIDALINP)
                ELSE QTVALIDAS * NVL(ITMAN.VRTOTITEM, VRMENSALIDALINP)
            END AS VRTOTALMENSAL,
            CASE WHEN (QTMINIMAFATLINP > QTVALIDAS )
                THEN QTMINIMAFATLINP * NVL(ITLU.VRTOTITEM, VRLICENCUSOLINP)
                ELSE QTVALIDAS * NVL(ITLU.VRTOTITEM, VRLICENCUSOLINP)
            END AS VRTOTALLU,
            NMLINPCLIE AS NMLINPCLIE_AUX,
            (NMLINPCLIE || ' - ' || '(' ||
            (SELECT RTRIM(XMLAGG(XMLELEMENT(e,SI.SGSISTEMA ,', ').EXTRACT('//text()')).GetClobVal(),', ')
                     FROM SISTCONTLINP SC, SISTEMA SI, PROCOMERCI PR
                     WHERE SC.CDCLIENTE = :P_CDCLIENTE
                     AND SC.CDLINPCLIE = CA.CDLINPCLIE
                     AND SI.CDSISTEMA = SC.CDSISTEMA
                     AND PR.CDPROCOMERCI = SI.CDPROCOMERCI) || ')') AS NMLINPCLIE,
            CONT.NRCONTRATOFCT,
            CONT.DSREFERENCIACONT,
            DECODE(NVL(ITMAN.VRPERCDESCITEM, 0), 0, NVL(ITMAN.VRDESCITEM, 0), ITMAN.VRTOTITEMCOMDESC * ITMAN.VRPERCDESCITEM / 100) AS VRDESCMANUTENCAO,
            DECODE(NVL(ITMAN.VRPERCDESCITEM, 0), 0, ITMAN.VRTOTITEMCOMDESC, ITMAN.VRTOTITEMCOMDESC - (ITMAN.VRTOTITEMCOMDESC * ITMAN.VRPERCDESCITEM / 100)) AS VRTOTMANUTENCAO,
            DECODE(NVL(ITLU.VRPERCDESCITEM, 0), 0, NVL(ITLU.VRDESCITEM, 0), ITLU.VRTOTITEMCOMDESC * ITLU.VRPERCDESCITEM / 100) AS VRDESCLICENCAUSO,
            DECODE(NVL(ITLU.VRPERCDESCITEM, 0), 0, ITLU.VRTOTITEMCOMDESC, ITLU.VRTOTITEMCOMDESC - (ITLU.VRTOTITEMCOMDESC * ITLU.VRPERCDESCITEM / 100)) AS VRTOTLICENCAUSO
      FROM (SELECT CX.CAIXAS, C.NRSEQCONTRATO, C.NRPRODUTO_ID, T.*
              FROM TABLE (LINHA_PRODUTO_FAT (:P_CDCLIENTE)) T, CONTRATOLINP C,
                   (SELECT CO.CDCLIENTE, CO.CDLINPCLIE, CO.NMLINPCLIE, NVL(CN.TOTAL,0) AS CAIXAS
                      FROM CONTRATOLINP CO,
                           (SELECT SUM(C.TOTAL) AS TOTAL, L.CDLINPCLIE
                              FROM LINPLUSO L,
                                   (SELECT CDCLIENTE, NRLICENCAUSO, COUNT(CDCAIXALUSO) AS TOTAL
                                      FROM CAIXALUSO
                                     WHERE CDCLIENTE= :P_CDCLIENTE
                                  GROUP BY CDCLIENTE, NRLICENCAUSO
                                   )C
                             WHERE L.CDCLIENTE    = C.CDCLIENTE
                               AND L.NRLICENCAUSO = C.NRLICENCAUSO
                          GROUP BY L.CDLINPCLIE
                           ) CN
                      WHERE CO.CDLINPCLIE = CN.CDLINPCLIE(+)
                        AND CO.CDCLIENTE = :P_CDCLIENTE
                   ) CX
             WHERE T.CDCLIENTE = CX.CDCLIENTE
               AND T.CDLINPCLIE = CX.CDLINPCLIE
               AND C.CDCLIENTE = T.CDCLIENTE
               AND C.CDLINPCLIE = T.CDLINPCLIE) CA,
               FCT_CONTRATO CONT,
            (SELECT NEG.NRSEQCONTRATO, ITCONT.IDELEMENTO, NEG.VRPERCDESCITEM, ITNEG.VRDESCITEM, ITNEG.VRTOTITEM, ITNEG.VRTOTITEMCOMDESC
               FROM FCT_NEGOCIACAOCONTRATO NEG
              INNER JOIN FCT_ITEMCONTRATO ITCONT
                 ON NEG.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
              INNER JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG
                 ON NEG.NRNEGOCIACAOCONTRATO = ITNEG.NRNEGOCIACAOCONTRATO
                AND ITCONT.NRITEMOCONTRATO = ITNEG.NRITEMOCONTRATO
              INNER JOIN FCT_SERVICOORCA SERV
                 ON ITCONT.CDSERVORCA = SERV.CDSERVORCA
              WHERE SERV.IDLICENUSOMANUT = 'M') ITMAN,
            (SELECT NEG.NRSEQCONTRATO, ITCONT.IDELEMENTO, NEG.VRPERCDESCITEM, ITNEG.VRDESCITEM, ITNEG.VRTOTITEM, ITNEG.VRTOTITEMCOMDESC
               FROM FCT_NEGOCIACAOCONTRATO NEG
              INNER JOIN FCT_ITEMCONTRATO ITCONT
                 ON NEG.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
              INNER JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG
                 ON NEG.NRNEGOCIACAOCONTRATO = ITNEG.NRNEGOCIACAOCONTRATO
                AND ITCONT.NRITEMOCONTRATO = ITNEG.NRITEMOCONTRATO
              INNER JOIN FCT_SERVICOORCA SERV
                 ON ITCONT.CDSERVORCA = SERV.CDSERVORCA
              WHERE SERV.IDLICENUSOMANUT = 'L') ITLU
           WHERE CA.NRSEQCONTRATO = CONT.NRSEQCONTRATO(+)
             AND CA.NRSEQCONTRATO = ITMAN.NRSEQCONTRATO(+)
             AND ITMAN.IDELEMENTO(+) = 'P_' || CA.NRPRODUTO_ID
             AND CA.NRSEQCONTRATO = ITLU.NRSEQCONTRATO(+)
             AND ITLU.IDELEMENTO(+) = 'P_' || CA.NRPRODUTO_ID
     ORDER BY DECODE(IDTIPLINPC, 'M', 1, 'L', 1, 'P', 2, 'A', 2, NULL, 0), NMLINPCLIE_AUX)
     WHERE VRDESCLICENCAUSO > 0 OR NRSEQCONTRATO IS NOT NULL
SQL;
        $params = array('P_CDCLIENTE' => $clientId);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function findMonthBilling($billingDate, $clientId)
    {
        $query = <<<SQL
            SELECT CLA.CDCLIENTE, CLA.CDLINPCLIE, CLA.IDTIPLINPCAPUR AS IDTIPLINPC, CLA.IDTIPLINPCAPUR AS IDTIPLINPC_FORM,
                   QTS.QTSISTEMAS, CLA.NRUSUALINPAPUR AS NRUSUALINPC, CLA.IDMPROCLINPAPUR || '/' || CLA.IDLPROCLINPAPUR AS MODE_LOCATION,
                   CLA.VRLICENCUSOAPUR AS VRLICENCUSOLINP, NVL(QTA.QTATIVAS,0) QTATIVAS , NVL(QTV.QTVALIDAS,0) QTVALIDAS,
                   NVL(CLA.QTMINIMAFATAPUR,0) QTMINIMAFATLINP, CLA.VRMENSALIDAAPUR AS VRMENSALIDALINP,'$billingDate' AS DTFATURAMENTO,
                   ' ' AS GROUPED,
                   CASE WHEN (NVL(CLA.QTMINIMAFATAPUR,0) > NVL(QTV.QTVALIDAS,0))
                        THEN NVL(CLA.QTMINIMAFATAPUR,0) * CLA.VRMENSALIDAAPUR
                        ELSE NVL(QTV.QTVALIDAS,0) * CLA.VRMENSALIDAAPUR
                    END AS VRTOTALMENSAL,
                    (CLA.NMLINPCLIEAPUR || ' - ' || '(' ||
                    (SELECT RTRIM(XMLAGG(XMLELEMENT(e,SI.SGSISTEMA ,', ').EXTRACT('//text()')).GetClobVal(),', ')
                             FROM SISTCONTLINP SC, SISTEMA SI, PROCOMERCI PR
                             WHERE SC.CDCLIENTE = :P_CDCLIENTE
                             AND SC.CDLINPCLIE = CLA.CDLINPCLIE
                             AND SI.CDSISTEMA = SC.CDSISTEMA
                             AND PR.CDPROCOMERCI = SI.CDPROCOMERCI) || ')') AS NMLINPCLIE
              FROM CONTRATOLINPAPU CLA,
                   (SELECT SI.CDCLIENTE, SI.CDLINPCLIE, COUNT(*) AS QTSISTEMAS
                      FROM SISTCONTLINPAPU SI
                     WHERE SI.CDCLIENTE = :P_CDCLIENTE
                       AND SI.DTMESAPURLINP = :P_DATA
                  GROUP BY SI.CDCLIENTE, SI.CDLINPCLIE) QTS,
                   (SELECT LL.CDCLIENTE, LL.CDLINPCLIE, COUNT(*) AS QTATIVAS
                      FROM CONTRATOLINPAPU CL, LINPLUSOAPUR LL
                     WHERE LL.CDCLIENTE = :P_CDCLIENTE
                       AND LL.DTMESAPURLINP = :P_DATA
                       AND LL.IDLUSOATIVAPUR = 'S'
                       AND CL.CDCLIENTE = LL.CDCLIENTE
                       AND CL.CDLINPCLIE = LL.CDLINPCLIE
                       AND CL.DTMESAPURLINP = LL.DTMESAPURLINP
                       AND CL.IDTIPLINPCAPUR IN ('M', 'L')
                     GROUP BY LL.CDCLIENTE, LL.CDLINPCLIE
                     UNION ALL
                    SELECT LL.CDCLIENTE, LL.CDLINPCLIE, COUNT(*) AS QTATIVAS
                      FROM CONTRATOLINPAPU CL, CAIXALUSOAPUR CX, LINPLUSOAPUR LL
                     WHERE LL.CDCLIENTE = :P_CDCLIENTE
                       AND LL.DTMESAPURLINP = :P_DATA
                       AND LL.IDLUSOATIVAPUR = 'S'
                       AND CL.CDCLIENTE = LL.CDCLIENTE
                       AND CL.CDLINPCLIE = LL.CDLINPCLIE
                       AND CL.DTMESAPURLINP = LL.DTMESAPURLINP
                       AND CL.IDTIPLINPCAPUR IN ('P', 'A')
                       AND CX.CDCLIENTE = LL.CDCLIENTE
                       AND CX.CDLINPCLIE = LL.CDLINPCLIE
                       AND CX.DTMESAPURLINP = LL.DTMESAPURLINP
                       AND CX.NRLICENCAUSO = LL.NRLICENCAUSO
                     GROUP BY LL.CDCLIENTE, LL.CDLINPCLIE) QTA,
                   (SELECT LL.CDCLIENTE, LL.CDLINPCLIE, COUNT(*) AS QTVALIDAS
                      FROM CONTRATOLINPAPU CL, LINPLUSOAPUR LL
                     WHERE LL.CDCLIENTE = :P_CDCLIENTE
                       AND LL.DTMESAPURLINP = :P_DATA
                       AND (LL.IDLUSOATIVAPUR = 'S' OR LL.DTVALIPERSAPUR > ADD_MONTHS(LAST_DAY(TRUNC(LL.DTMESAPURLINP)), -1))
                       AND CL.CDCLIENTE = LL.CDCLIENTE
                       AND CL.CDLINPCLIE = LL.CDLINPCLIE
                       AND CL.DTMESAPURLINP = LL.DTMESAPURLINP
                       AND CL.IDTIPLINPCAPUR IN ('M', 'L')
                     GROUP BY LL.CDCLIENTE, LL.CDLINPCLIE
                     UNION ALL
                    SELECT LL.CDCLIENTE, LL.CDLINPCLIE, COUNT(*) AS QTVALIDAS
                      FROM CONTRATOLINPAPU CL, CAIXALUSOAPUR CX, LINPLUSOAPUR LL
                     WHERE LL.CDCLIENTE = :P_CDCLIENTE
                       AND LL.DTMESAPURLINP = :P_DATA
                       AND (LL.IDLUSOATIVAPUR = 'S' OR CX.DTVALIPERCXAPUR > ADD_MONTHS(LAST_DAY(TRUNC(CX.DTMESAPURLINP)), -1))
                       AND CL.CDCLIENTE = LL.CDCLIENTE
                       AND CL.CDLINPCLIE = LL.CDLINPCLIE
                       AND CL.DTMESAPURLINP = LL.DTMESAPURLINP
                       AND CL.IDTIPLINPCAPUR IN ('P', 'A')
                       AND CX.CDCLIENTE = LL.CDCLIENTE
                       AND CX.CDLINPCLIE = LL.CDLINPCLIE
                       AND CX.DTMESAPURLINP = LL.DTMESAPURLINP
                       AND CX.NRLICENCAUSO = LL.NRLICENCAUSO
                     GROUP BY LL.CDCLIENTE, LL.CDLINPCLIE) QTV
             WHERE CLA.CDCLIENTE = :P_CDCLIENTE
               AND CLA.DTMESAPURLINP = :P_DATA
               AND QTS.CDCLIENTE (+) = CLA.CDCLIENTE
               AND QTS.CDLINPCLIE (+) = CLA.CDLINPCLIE
               AND QTA.CDCLIENTE (+) = CLA.CDCLIENTE
               AND QTA.CDLINPCLIE (+) = CLA.CDLINPCLIE
               AND QTV.CDCLIENTE (+) = CLA.CDCLIENTE
               AND QTV.CDLINPCLIE (+) = CLA.CDLINPCLIE
             ORDER BY DECODE(CLA.IDTIPLINPCAPUR, 'M', 1, 'L', 1, 'P', 2, 'A', 2), CLA.NMLINPCLIEAPUR
SQL;
        $params = array(
            'P_CDCLIENTE' => $clientId,
            'P_DATA' => $billingDate
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

}
